<?php if (!defined('ROOTPATH')) exit('No direct script access allowed'); ?>
<?php
// Execute the deferred query and group the case assocs by the cases
// for easy and fast lookup
$case_assocs = group::by_id($case_assocs->result(), 'case_id');
?>
<?php $layout_results = $layout == TP_EXPORT_CSV_LAYOUT_RESULTS ?>
<?php $section_hierarchies = array() ?>
<?php $section = $sections->peek() ?>
<?php while ($section): ?>
<?php $section_lookup[$section->id] = $section ?>
<?php $sections->next() ?>
<?php $test = $tests->peek() ?>
<?php while ($test && $test->section_id == $section->id): ?>
<?php $tests->next() ?>
<?php if (isset($case_assocs[$test->content_id])): ?>
<?php $current_case_assocs = group::by_id_scalar(
	$case_assocs[$test->content_id]->items,
	'name',
	'value') ?>
<?php foreach ($current_case_assocs as $key => $value): ?>
<?php $test->$key = $value ?>
<?php endforeach ?>
<?php endif ?>
<?php
$current_test_changes = array();

$change = $test_changes->peek();
while ($change && $change->test_id == $test->id)
{
	$test_changes->next();
	$current_test_changes[] = $change;
	$change = $test_changes->peek();	
}

$milestone = null;
if ($test->milestone_id)
{
	$milestone = arr::get($milestone_lookup, $test->milestone_id);
}
?>
<?php $row_count = $layout_results ? max(1, count($current_test_changes)) : 1 ?>
<?php for ($i = 0; $i < $row_count; $i++): ?>
<?php $values = array() ?>
<?php $change = arr::get($current_test_changes, $i) ?>
<?php foreach ($columns as $column): ?>
<?php if (!isset($fields_csv[$column])): ?>
<?php continue ?>
<?php endif ?>
<?php
$value = null;
$is_encoded = false;

switch ($column)
{
	case 'tests:id':
		$value = entities::test_id($test->id);
		break;

	case 'cases:title':
		$value = $test->title;
		break;

	case 'cases:type_id':
		$value = $GI->cache->get_scalar(
			'case_type',
			$test->type_id,
			'name',
			''
		);
		break;

	case 'cases:priority_id':
		$value = $GI->cache->get_scalar(
			'priority',
			$test->priority_id,
			'name',
			''
		);
		break;

	case 'cases:milestone_id':
		if ($milestone)
		{
			$value = $milestone->name;
		}
		break;

	case 'cases:estimate':
		if ($test->estimate)
		{
			$value = $test->estimate . 's';
		}
		break;

	case 'cases:estimate_forecast':
		if ($test->estimate_forecast)
		{
			$value = $test->estimate_forecast . 's';
		}
		break;

	case 'cases:refs':
		if ($test->refs)
		{
			$value = references::format_nolinks($test->refs);
		}
		break;		

	case 'cases:section_id':
		$value = $section->name;
		break;

	case 'cases:section_full':
		// Compute the full section name (as in Section1 > Section 2)
		// on demand and cache the result afterwards.
		$value = arr::get($section_hierarchies, $section->id);
		if (!$value)
		{
			$value = sections::get_name_hierarchy(
				$section,
				$section_lookup,
				$section_hierarchies
			);
		}
		break;

	case 'cases:section_depth':
		$value = $section->depth;
		break;

	case 'cases:section_desc':
		$value = $section->description;
		break;

	case 'tests:assignedto_id':
		if ($test->assignedto_id)
		{
			$value = $GI->cache->get_scalar(
				'user',
				$test->assignedto_id,
				'name',
				''
			);
		}
		break;

	case 'tests:status_id':
		$status_id = null;
		if ($layout_results && $change)
		{
			$status_id = $change->status_id;
		}
		else 
		{
			$status_id = $test->status_id;
		}

		if ($status_id)
		{
			$value = $GI->cache->get_scalar(
				'status',
				$status_id,
				'label',
				''
			);
		}
		break;

	case 'tests:defects':
		if ($change && $change->defects)
		{
			$value = defects::format_nolinks($change->defects);
		}
		break;

	case 'tests:elapsed':
		if ($change && $change->elapsed)
		{
			$value = $change->elapsed . 's';
		}
		break;

	case 'tests:version':
		if ($change)
		{
			$value = $change->version;
		}
		break;

	case 'tests:comment':
		if ($change)
		{
			$value = $change->comment;
		}
		break;

	case 'tests:original_case_id':
		$value = entities::case_id($test->case_id);
		break;

	case 'tests:in_progress_by':
		if ($test->in_progress_by)
		{
			$value = $GI->cache->get_scalar(
				'user',
				$test->in_progress_by,
				'name',
				''
			);
		}
		break;

	case 'tests:run_id':
		$value = entities::run_id($run->id);
		break;

	case 'tests:run_name':
		$value = $run->name;
		break;

	case 'tests:run_config':
		$value = $run->config;
		break;

	case 'tests:plan_id':
		if ($plan)
		{
			$value = entities::run_id($plan->id);
		}
		break;

	case 'tests:plan_name':
		if ($plan)
		{
			$value = $plan->name;
		}
		break;

	case 'tests:tested_by':
		$tested_by = null;
		if ($layout_results && $change)
		{
			$tested_by = $change->user_id;
		}
		else 
		{
			$tested_by = $test->tested_by;
		}

		if ($tested_by)
		{
			$value = $GI->cache->get_scalar(
				'user',
				$tested_by,
				'name',
				''
			);
		}
		break;

	case 'tests:tested_on':
		$tested_on = null;
		if ($layout_results && $change)
		{
			$tested_on = $change->created_on;
		}
		else 
		{
			$tested_on = $test->tested_on;
		}

		if ($tested_on)
		{
			$value = date::format_short_datetime($tested_on);
		}
		break;

	default:
		// We deal with a custom field (or unknown/unsupported column) if
		// we reach this point. We first check if we deal with a sub-field
		// of a custom field (such as tests:custom_step_results.step).
		// We split the column into the system name and sub-property in
		// this case (and format the value differently, see below).
		$sub = null;

		$ix = str::pos($column, '.');
		if ($ix !== false)
		{
			$sub = str::sub($column, $ix + 1);
			$column = str::sub($column, 0, $ix);
		}

		$field = arr::get($fields, $column);
		if ($field && $change)
		{
			if ($sub)
			{
				$value = fields::export_value_partial(
					$field, 
					$change, 
					$sub,
					$exporter
				);
			}
			else 
			{
				$value = fields::export_value(
					$field, 
					$change, 
					$exporter
				);
			}

			$is_encoded = true; // Custom fields do their own encoding
		}
		break;
}

if ($value !== null)
{
	if (!$is_encoded)
	{
		// System field are encoded/escaped here (replace " to "")
		$value = csv::encode($value);
	}
}
else 
{
	$value = '';
}

$values[] = $value;
?>
<?php endforeach ?>
<?php echo  csv::join($values, $separator) ?>
<?php endfor ?>
<?php $test = $tests->peek() ?>
<?php endwhile ?>
<?php $section = $sections->peek() ?>
<?php endwhile ?>